Subject: Re: emac/zmii link warnings

From: Sean MacLennan <[email-masked]>
Date: Tue, 15 Jan 2008 00:45:33 -0500

Stephen Rothwell wrote:
> On Mon, 14 Jan 2008 23:15:41 -0500 Sean MacLennan <[email-masked]> wrote:
>   
>> I keep getting these link(?) warnings:
>>
>> WARNING: vmlinux.o(.data+0x16178): Section mismatch: reference to .init.text:emac_of_bus_notify (between 'emac_of_bus_notifier' and 'emac_phy_map_lock')
>>     
>
> emac_of_bus_notify is marked __devinit and is referred to by
> emac_of_bus_notifier (which is not marked thus) (in
> drivers/net/ibm_newemac/core.c).
>
>   
The __devinitdata solves this.
>> WARNING: vmlinux.o(.init.text+0x16ba8): Section mismatch: reference to .exit.text:zmii_detach (between 'emac_probe' and 'zmii_probe')
>> WARNING: vmlinux.o(.init.text+0x16bb4): Section mismatch: reference to .exit.text:mal_unregister_commac (between 'emac_probe' and 'zmii_probe')
>>     
>
> These will be similar but function calls.
>
>   
The problem here is that emac_probe calls zmii_detach. emacs_probe is a 
__devinit and zmii_detach is a __devexit. At least I assume that is the 
problem.

I am a long time emacs (actually xemacs) user. If I had a nickel for 
every time I typed emacs rather than emac, I would be a very rich man.

Cheers,
   Sean